當我在 leetcode 上解決問題時,該問題說在給定的按非遞減順序排序的整數數組 nums 中,找到給定目標值的開始和結束位置。因此不可能用簡單的二進位 Sarch 來傳回數組中目標元素的開始和結束,因為它只傳回找到第一個目標元素的索引,該元素可以是該元素的第一個、結尾或中間的任何內容。所以我們使用 Double Binary Scarch ,具體方法如下...
第一次二分查找:
第二次二分查找:
回傳結果:
時間複雜度:
空間複雜度:
class Solution { public int[] searchRange(int[] nums, int target) { int ei = nums.length - 1; int si = 0; int[] res = {-1, -1}; // Initialize result array // First binary search to find the last occurrence while (si <= ei) { int mid = si + (ei - si) / 2; if (target < nums[mid]) { ei = mid - 1; } else if (target > nums[mid]) { si = mid + 1; } else { res[1] = mid; // Update end index si = mid + 1; // Search in the right half } } // Reset the pointers for the second binary search si = 0; ei = nums.length - 1; // Second binary search to find the first occurrence while (si <= ei) { int mid = si + (ei - si) / 2; if (target < nums[mid]) { ei = mid - 1; } else if (target > nums[mid]) { si = mid + 1; } else { res[0] = mid; // Update start index ei = mid - 1; // Search in the left half } } return res; // Return the result array } }
以上是如何使用進階二進制搜尋?的詳細內容。更多資訊請關注PHP中文網其他相關文章!